<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.dcsoft.system.mapper.SysManageRecordMapper">

    <resultMap type="SysManageRecord" id="SysManageRecordResult">
        <result property="id"    column="id"    />
        <result property="type"    column="type"    />
        <result property="peopleId"    column="people_id"    />
        <result property="branchId"    column="branch_id"    />
        <result property="ruleId"    column="rule_id"    />
        <result property="remark"    column="remark"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <association property="branch"    column="branch_id" javaType="SysBranch" resultMap="branchResult" />
        <association property="people"    column="people_id" javaType="SysPeople" resultMap="peopleResult" />
        <association property="rule"    column="rule_id" javaType="SysRule" resultMap="ruleResult" />

    </resultMap>

    <resultMap id="branchResult" type="SysBranch">
        <id     property="id"    column="branch_id"     />
        <result property="name"  column="branchName"   />
    </resultMap>

    <resultMap id="peopleResult" type="SysPeople">
        <id     property="id"    column="people_id"     />
        <result property="name"  column="peopleName"   />
    </resultMap>

    <resultMap id="ruleResult" type="SysRule">
        <id     property="id"    column="rule_id"     />
        <result property="name"  column="ruleName"   />
    </resultMap>

    <sql id="selectSysManageRecordVo">
        select smr.id, smr.type, smr.people_id, smr.branch_id, smr.rule_id, smr.remark, smr.create_by, smr.create_time, smr.update_by, smr.update_time,
               b.name branchName ,p.name peopleName ,r.name ruleName
        from sys_manage_record smr
        left join sys_branch b on smr.branch_id=b.id
        left join sys_people p on smr.people_id=p.id
        left join sys_rule r on smr.rule_id=r.id
    </sql>

    <select id="selectSysManageRecordList" parameterType="SysManageRecord" resultMap="SysManageRecordResult">
        <include refid="selectSysManageRecordVo"/>
        <where>
            <if test="type != null "> and smr.type = #{type}</if>
            <if test="peopleId != null "> and smr.people_id = #{peopleId}</if>
            <if test="branchId != null "> and smr.branch_id = #{branchId}</if>
            <if test="ruleId != null "> and smr.rule_id = #{ruleId}</if>
        </where>
    </select>

    <select id="selectSysManageRecordById" parameterType="Long" resultMap="SysManageRecordResult">
        <include refid="selectSysManageRecordVo"/>
        where smr.id = #{id}
    </select>

    <insert id="insertSysManageRecord" parameterType="SysManageRecord" useGeneratedKeys="true" keyProperty="id">
        insert into sys_manage_record
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="type != null">type,</if>
            <if test="peopleId != null">people_id,</if>
            <if test="branchId != null">branch_id,</if>
            <if test="ruleId != null">rule_id,</if>
            <if test="remark != null">remark,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="type != null">#{type},</if>
            <if test="peopleId != null">#{peopleId},</if>
            <if test="branchId != null">#{branchId},</if>
            <if test="ruleId != null">#{ruleId},</if>
            <if test="remark != null">#{remark},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
         </trim>
    </insert>

    <update id="updateSysManageRecord" parameterType="SysManageRecord">
        update sys_manage_record
        <trim prefix="SET" suffixOverrides=",">
            <if test="type != null">type = #{type},</if>
            <if test="peopleId != null">people_id = #{peopleId},</if>
            <if test="branchId != null">branch_id = #{branchId},</if>
            <if test="ruleId != null">rule_id = #{ruleId},</if>
            <if test="remark != null">remark = #{remark},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteSysManageRecordById" parameterType="Long">
        delete from sys_manage_record where id = #{id}
    </delete>

    <delete id="deleteSysManageRecordByIds" parameterType="String">
        delete from sys_manage_record where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
</mapper>
